## febug 0.1.1+dfsg

=== Makefile ===
# SPDX-License-Identifier: MIT


CXX ?= c++
CC ?= cc
CPP ?= cpp
MANDOC ?= mandoc
AWK ?= awk
CARGO ?= cargo
LTO ?= y
FEBUG_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
FEBUG_DATE ?= $(shell date $(shell date --version > /dev/null 2>&1 && echo "--date @" || echo "-r ")$(shell git log -1 --no-show-signature --format=%at) +"%B %d, %Y")
EXTRACCAR ?=
EXTRALDAR ?=

SYSTEM := $(shell uname -s)
ifeq "$(SYSTEM)" "NetBSD"
	FUSE_ARGS ?= -lrefuse
else ifeq "$(SYSTEM)" "OpenBSD"
	FUSE_ARGS ?= -lfuse
else
	FUSE_ARGS ?= $(shell pkg-config --libs --cflags fuse3)
endif

CXXVER := $(shell $(CXX) --version | head -1)
ifneq "$(findstring clang,$(CXXVER))" ""
	# GCC doesn't have this granularity
	CXXSPECIFICCC := -Wpedantic -Wno-c++20-designator -Wno-c99-extensions -Wno-unknown-warning-option
	ifeq "$(LTO)" "y"
		CXXSPECIFICLD := -flto=full  # Clang produces .o files with LLVM bitcode, which cannot be linked to if put in .as
	else
		CXXSPECIFICLD :=
	endif
else
	CXXSPECIFICCC := -Wno-missing-field-initializers -fno-common
	ifeq "$(LTO)" "y"
		CXXSPECIFICCC += -flto
	endif
	CXXSPECIFICLD :=
endif


OUTDIR ?= out/
OBJDIR ?= $(OUTDIR)obj/
CCAR := -g -O3 -pipe -Wall -Wextra -isysteminclude/ $(CXXSPECIFICCC) $(EXTRACCAR)
LDAR := -Wl,--as-needed -L$(OUTDIR) $(CXXSPECIFICLD) $(EXTRALDAR)
HEADERS := $(wildcard include/*.h include/*.hpp)
EXAMPLES := $(wildcard examples/*.c examples/*.cpp)
EXAMPLES_RS := $(wildcard examples/*.rs)
MANPAGES := $(wildcard man/*.[0123456789])
FEBUG_VERSION := $(FEBUG_VERSION)
FEBUG_DATE := $(FEBUG_DATE)
FUSE_ARGS := $(FUSE_ARGS)


.PHONY : main libfebug++ libfebug examples manpages rust-build rust-doc

all : main libfebug++ libfebug examples manpages how.png
clean:
	rm -rf $(OUTDIR) $(OBJDIR) how.png

main : $(OUTDIR)febug
libfebug++ : $(OUTDIR)libfebug++.a
libfebug : $(OUTDIR)libfebug.a $(OUTDIR)libfebug.so
examples : $(foreach l,$(patsubst %.c,$(OUTDIR)%,$(patsubst %pp,%,$(EXAMPLES))),$(l) $(l)-dont)
manpages : $(patsubst %,$(OUTDIR)%,$(MANPAGES)) $(OBJDIR)man/aliases
rust-build : $(OUTDIR)febug.rs/target/libfebug.rlib
rust-doc : $(OUTDIR)febug.rs/doc/febug/index.html


$(OUTDIR)febug : main.cpp $(HEADERS)
	@mkdir -p $(dir $@)
	$(CXX) $< -o$@ -DFEBUG_VERSION='$(FEBUG_VERSION)' -std=c++17 -fno-exceptions -fPIE $(CCAR) $(LDAR) $(FUSE_ARGS)


$(OBJDIR)febug++.o : febug.cpp $(HEADERS)
	@mkdir -p $(dir $@)
	$(CXX) -c $< -o$@ -std=c++17 -fPIC $(CCAR)

$(OUTDIR)libfebug++.a : $(OBJDIR)febug++.o
	@mkdir -p $(dir $@)
	ar crs $@ $^


$(OBJDIR)febug.o : febug.c $(HEADERS)
	@mkdir -p $(dir $@)
	$(CC) -c $< -o$@ -std=c11 -fPIC $(CCAR)

$(OUTDIR)libfebug.a : $(OBJDIR)febug.o
	@mkdir -p $(dir $@)
	ar crs $@ $^

$(OUTDIR)libfebug.so : $(OBJDIR)febug.o
	@mkdir -p $(dir $@)
	$(CC) -shared $< -o$(OUTDIR)libfebug.so.0 -std=c11 -fPIC $(CCAR) $(LDAR) -Wl,-soname,libfebug.so.0
	ln -fs libfebug.so.0 $@


$(OUTDIR)examples/% : examples/%.cpp $(OUTDIR)libfebug++.a $(HEADERS)
	@mkdir -p $(dir $@)
	$(CXX) $< -o$@              -std=c++17 -fPIE $(CCAR) $(LDAR) -lfebug++

$(OUTDIR)examples/%-dont : examples/%.cpp $(OUTDIR)libfebug++.a $(HEADERS)
	@mkdir -p $(dir $@)
	$(CXX) $< -o$@ -DFEBUG_DONT -std=c++17 -fPIE $(CCAR) $(LDAR) -lfebug++

$(OUTDIR)examples/% : examples/%.c $(OUTDIR)libfebug.a $(HEADERS)
	@mkdir -p $(dir $@)
	$(CC) $< -o$@              -std=c11 -fPIE $(CCAR) $(LDAR) -lfebug

$(OUTDIR)examples/%-dont : examples/%.c $(OUTDIR)libfebug.a $(HEADERS)
	@mkdir -p $(dir $@)
	$(CC) $< -o$@ -DFEBUG_DONT -std=c11 -fPIE $(CCAR) $(LDAR) -lfebug


$(OBJDIR)man/aliases : man/aliases
	@mkdir -p $(dir $@)
	@touch $@
	$(AWK) '!/^$$/ {print "ln -fs " $$1 " $(OUTDIR)man/" $$2}' man/aliases | sh -x

LP := (
RP := )
$(OUTDIR)man/% : man/% man/style.css $(wildcard man/*.h)
	@mkdir -p $(dir $@) $(dir $(OBJDIR)$<)
	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<)) | \
		grep -v '^$$' | \
		(cd $(dir $<); $(AWK) '$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\\\", line); print line}; next}  {print}') \
		> $(OBJDIR)$<
	$(MANDOC) -Tman $(OBJDIR)$< > $@
	$(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I" $(OBJDIR)$< | \
		$(AWK) '/<\/style>/ {print "<style>"; while(getline < "man/style.css") print; $$0 = "</style>"; print} /<style>/,/<\/style>/ {next}  {print}' | \
		sed -re 's/ title=".."//g' $(foreach l,$(subst man/,,$(MANPAGES)), -e 's;(<a class="Xr")>($(subst +,\+,$(subst \$(LP)rs,.rs,$(subst .,\$(LP),$(l))\$(RP))))</a>;\1 href="$(l).html">\2</a>;') > $@.html
# $(MANDOC) -Tlint $(OBJDIR)$<


$(OUTDIR)febug.rs/README.md : README.md
	@mkdir -p $(dir $@)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/%.rs : febug.rs/%.rs
	@mkdir -p $(dir $@)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/examples/%.rs : examples/%.rs
	@mkdir -p $(dir $@)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/target/libfebug.rlib : $(OUTDIR)febug.rs/Cargo.toml $(OUTDIR)febug.rs/lib.rs $(OUTDIR)febug.rs/build.rs $(OUTDIR)febug.rs/README.md $(patsubst %,$(OUTDIR)febug.rs/%,$(EXAMPLES_RS))
	@mkdir -p $(OUTDIR)examples/
	cd $(dir $<); FEBUG_DONT=1 $(CARGO) build --release --examples
	$(foreach l,$(patsubst %.rs,%,$(EXAMPLES_RS)),mv $(OUTDIR)febug.rs/target/release/$(l) $(OUTDIR)$(l)-dont; )
	cd $(dir $<); $(CARGO) build --release --examples
	$(foreach l,$(patsubst %.rs,%,$(EXAMPLES_RS)),mv $(OUTDIR)febug.rs/target/release/$(l) $(OUTDIR)$(l); )

$(OUTDIR)febug.rs/doc/febug/index.html : $(OUTDIR)febug.rs/target/libfebug.rlib
	cd $(dir $<); $(CARGO) doc --release

$(OUTDIR)febug.rs/Cargo.toml : febug.rs/Cargo.toml
	@mkdir -p $(dir $@)
	sed -e 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@


how.png : how.dot
	dot -Tpng $^ -o $@

=== debian/changelog ===
febug (0.1.1+dfsg-1) unstable; urgency=medium

  * Initial packaging, upstream version 0.1.1+dfsg
    (removed generated graphviz graph)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Tue, 08 Dec 2020 18:35:44 +0100

=== debian/control ===
Source: febug
Section: debug
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/febug.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/febug.deb
Homepage: https://sr.ht/~nabijaczleweli/febug
Build-Depends: debhelper,
               debhelper-compat (= 13),
               pkg-config,
               mandoc,
               graphviz,
               libfuse3-dev,

Package: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
Description: Cooperative debugging filesystem, inspired by debugfs
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the FUSE-based driver.

Package: libfebug0
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C library
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the run-time C library.

Package: libfebug-dev
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C development files
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the development files and man-pages for the C library.

Package: libfebug++-dev
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the development files and man-pages for the C++ library.

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

VERSION = "$(shell awk '{gsub(/[)(]/, ""); print $$2; exit}' debian/changelog)"
DATE = $(shell awk '/^ --/ {sub(/^0/, "", $$5); print $$6 " " $$5 ", " $$7}' debian/changelog)

export FEBUG_VERSION=$(VERSION)
export FEBUG_DATE=$(DATE)
export EXTRACCAR=$(subst -O2,,$(shell dpkg-buildflags --get CFLAGS))
export EXTRALDAR=$(shell dpkg-buildflags --get LDFLAGS)


override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md how.png

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/febug-$1\.tar\.gz/,\
dversionmangle=s/\+dfsg//,repacksuffix=+dfsg" \
  https://git.sr.ht/~nabijaczleweli/febug/refs .*/v?(\d\S+)\.tar\.gz

## febug 0.1.2+dfsg

=== debian/changelog ===
febug (0.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 0.1.2+dfsg
  * Don't define _FILE_OFFSET_BITS in Makefile,
    since upstream now does so in main.cpp

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 31 Jan 2021 15:33:46 +0100

febug (0.1.1+dfsg-2) unstable; urgency=medium

  * Fix build on i386 by always defining -D_FILE_OFFSET_BITS=64
    (cf. #981012, thanks, GCS!)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 25 Jan 2021 18:41:13 +0100

## febug 0.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -9,15 +9,21 @@
 CARGO ?= cargo
 LTO ?= y
 FEBUG_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
-FEBUG_DATE ?= $(shell date $(shell date --version > /dev/null 2>&1 && echo "--date @" || echo "-r ")$(shell git log -1 --no-show-signature --format=%at) +"%B %d, %Y")
+FEBUG_DATE ?= $(shell date $(shell date --version > /dev/null 2>&1 && echo "--date @" || echo "-r ")$(shell git log -1 --no-show-signature --format=%at) +"%B %e, %Y")
 EXTRACCAR ?=
 EXTRALDAR ?=
 
+AS_NEEDED := -Wl,--as-needed
+SONAME := -soname
 SYSTEM := $(shell uname -s)
 ifeq "$(SYSTEM)" "NetBSD"
 	FUSE_ARGS ?= -lrefuse
 else ifeq "$(SYSTEM)" "OpenBSD"
 	FUSE_ARGS ?= -lfuse
+else ifeq "$(SYSTEM)" "Darwin"
+	FUSE_ARGS ?= -lfuse
+	AS_NEEDED :=
+	SONAME := -install_name
 else
 	FUSE_ARGS ?= $(shell pkg-config --libs --cflags fuse3)
 endif
@@ -26,6 +32,10 @@
 ifneq "$(findstring clang,$(CXXVER))" ""
 	# GCC doesn't have this granularity
 	CXXSPECIFICCC := -Wpedantic -Wno-c++20-designator -Wno-c99-extensions -Wno-unknown-warning-option
+ifneq "$(findstring Apple,$(CXXVER))" ""
+	# CMSG_SPACE() is a macro, and it's decidedly constexpr. i don't care if appleclang can't figure that out
+	CXXSPECIFICCC += -Wno-vla-extension
+endif
 	ifeq "$(LTO)" "y"
 		CXXSPECIFICLD := -flto=full  # Clang produces .o files with LLVM bitcode, which cannot be linked to if put in .as
 	else
@@ -43,7 +53,7 @@
 OUTDIR ?= out/
 OBJDIR ?= $(OUTDIR)obj/
 CCAR := -g -O3 -pipe -Wall -Wextra -isysteminclude/ $(CXXSPECIFICCC) $(EXTRACCAR)
-LDAR := -Wl,--as-needed -L$(OUTDIR) $(CXXSPECIFICLD) $(EXTRALDAR)
+LDAR := $(AS_NEEDED) -L$(OUTDIR) $(CXXSPECIFICLD) $(EXTRALDAR)
 HEADERS := $(wildcard include/*.h include/*.hpp)
 EXAMPLES := $(wildcard examples/*.c examples/*.cpp)
 EXAMPLES_RS := $(wildcard examples/*.rs)
@@ -53,9 +63,9 @@
 FUSE_ARGS := $(FUSE_ARGS)
 
 
-.PHONY : main libfebug++ libfebug examples manpages rust-build rust-doc
+.PHONY : main libfebug++ libfebug examples manpages htmlpages rust-build rust-doc
 
-all : main libfebug++ libfebug examples manpages how.png
+all : main libfebug++ libfebug examples manpages htmlpages how.png
 clean:
 	rm -rf $(OUTDIR) $(OBJDIR) how.png
 
@@ -64,6 +74,7 @@
 libfebug : $(OUTDIR)libfebug.a $(OUTDIR)libfebug.so
 examples : $(foreach l,$(patsubst %.c,$(OUTDIR)%,$(patsubst %pp,%,$(EXAMPLES))),$(l) $(l)-dont)
 manpages : $(patsubst %,$(OUTDIR)%,$(MANPAGES)) $(OBJDIR)man/aliases
+htmlpages : $(patsubst %,$(OUTDIR)%.html,$(MANPAGES)) $(OUTDIR)man/style.css
 rust-build : $(OUTDIR)febug.rs/target/libfebug.rlib
 rust-doc : $(OUTDIR)febug.rs/doc/febug/index.html
 
@@ -92,7 +103,7 @@
 
 $(OUTDIR)libfebug.so : $(OBJDIR)febug.o
 	@mkdir -p $(dir $@)
-	$(CC) -shared $< -o$(OUTDIR)libfebug.so.0 -std=c11 -fPIC $(CCAR) $(LDAR) -Wl,-soname,libfebug.so.0
+	$(CC) -shared $< -o$(OUTDIR)libfebug.so.0 -std=c11 -fPIC $(CCAR) $(LDAR) -Wl,$(SONAME),libfebug.so.0
 	ln -fs libfebug.so.0 $@
 
 
@@ -118,20 +129,21 @@
 	@touch $@
 	$(AWK) '!/^$$/ {print "ln -fs " $$1 " $(OUTDIR)man/" $$2}' man/aliases | sh -x
 
-LP := (
-RP := )
-$(OUTDIR)man/% : man/% man/style.css $(wildcard man/*.h)
-	@mkdir -p $(dir $@) $(dir $(OBJDIR)$<)
-	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<)) | \
-		grep -v '^$$' | \
-		(cd $(dir $<); $(AWK) '$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\\\", line); print line}; next}  {print}') \
-		> $(OBJDIR)$<
-	$(MANDOC) -Tman $(OBJDIR)$< > $@
-	$(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I" $(OBJDIR)$< | \
-		$(AWK) '/<\/style>/ {print "<style>"; while(getline < "man/style.css") print; $$0 = "</style>"; print} /<style>/,/<\/style>/ {next}  {print}' | \
-		sed -re 's/ title=".."//g' $(foreach l,$(subst man/,,$(MANPAGES)), -e 's;(<a class="Xr")>($(subst +,\+,$(subst \$(LP)rs,.rs,$(subst .,\$(LP),$(l))\$(RP))))</a>;\1 href="$(l).html">\2</a>;') > $@.html
-# $(MANDOC) -Tlint $(OBJDIR)$<
+$(OUTDIR)man/% : man/% $(wildcard man/*.h)
+	@mkdir -p $(dir $@)
+	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<) | \
+		$(AWK) '/^$$/ {next}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  \
+			$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\e", line); print line}; next}  \
+			{print}') > $@
+	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'WARNING: unknown manual section: Dt .* 0$$' -e 'STYLE: operating system explicitly specified: Os febug' -e 'STYLE: input text line longer than 80 bytes' -e 'STYLE: .*OpenBSD' -e 'STYLE: RCS id missing'
 
+$(OUTDIR)man/%.html : $(OUTDIR)man/%
+	(cd man/; $(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I",man="%N.%S.html;https://manpages.debian.org/bullseye/%N.%S",style="style.css" ../$^ | \
+		sed -Ee 's/ title=".."//g') > $@
+
+$(OUTDIR)man/style.css : man/style.css
+	@mkdir -p $(dir $@)
+	ln -f $^ $@ 2>/dev/null || cp $^ $@
 
 $(OUTDIR)febug.rs/README.md : README.md
 	@mkdir -p $(dir $@)
@@ -157,7 +169,7 @@
 
 $(OUTDIR)febug.rs/Cargo.toml : febug.rs/Cargo.toml
 	@mkdir -p $(dir $@)
-	sed -e 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@
+	sed 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@
 
 
 how.png : how.dot

=== debian/changelog ===
febug (0.2.0+dfsg-1) unstable; urgency=medium

  * Fix uscan filenamemangle
  * New upstream version 0.2.0+dfsg
  * Update upstream changelog
  * Drop now-superfluous mandoc dependency
  * Use a single long date from d/changelog
  * Fix libfebug.rs.3 install location (it's not libfebug.3 translated into rs!)
  * Install systemd units (off by default)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Thu, 09 Dec 2021 12:05:10 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
 Build-Depends: debhelper,
                debhelper-compat (= 13),
                pkg-config,
-               mandoc,
                graphviz,
                libfuse3-dev,

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

VERSION = "$(shell awk '{gsub(/[)(]/, ""); print $$2; exit}' debian/changelog)"
DATE = $(shell awk '/^ --/ {sub(/^0/, "", $$5); print $$6 " " $$5 ", " $$7; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')

export FEBUG_VERSION=$(VERSION)
export FEBUG_DATE=$(DATE)
export EXTRACCAR=$(subst -O2,,$(shell dpkg-buildflags --get CFLAGS))
export EXTRALDAR=$(shell dpkg-buildflags --get LDFLAGS)
export MANDOC=true


override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_installsystemduser:
	dh_installsystemduser --no-enable

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md how.png

override_dh_installman:
	dh_installman --language=C

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s/v?(\d\S+)\.tar\.gz/febug-$1\.tar\.gz/,\
dversionmangle=s/\+dfsg//,repacksuffix=+dfsg" \
  https://git.sr.ht/~nabijaczleweli/febug/refs .*/v?(\d\S+)\.tar\.gz

## febug 0.2.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -134,7 +134,7 @@
 	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<) | \
 		$(AWK) '/^$$/ {next}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  \
 			$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\e", line); print line}; next}  \
-			{print}') > $@
+			{sub(/^~/, "\\(ti"); gsub(/([^\\])~/, "&_BUT-TI_"); gsub(/~_BUT-TI_/, "\\(ti"); print}') > $@
 	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'WARNING: unknown manual section: Dt .* 0$$' -e 'STYLE: operating system explicitly specified: Os febug' -e 'STYLE: input text line longer than 80 bytes' -e 'STYLE: .*OpenBSD' -e 'STYLE: RCS id missing'
 
 $(OUTDIR)man/%.html : $(OUTDIR)man/%

=== debian/changelog ===
febug (0.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 0.2.1+dfsg
  * Include headers properly in -dev packages
  * libfebug++-dev Depends: libfebug-dev
  * Update upstream changelog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 12 Jun 2023 17:50:08 +0200

=== debian/control ===
--- 
+++ 
@@ -60,7 +60,8 @@
 Package: libfebug++-dev
 Recommends: febug
 Architecture: any
-Depends: ${misc:Depends},
+Depends: libfebug-dev,
+         ${misc:Depends},
          ${shlibs:Depends},
 Tag: implemented-in::c, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files

## febug 1.0.0+dfsg

=== Makefile ===
# SPDX-License-Identifier: MIT


CXX ?= c++
CC ?= cc
CPP ?= cpp
MANDOC ?= mandoc
AWK ?= awk
PKGCONF ?= pkgconf
PYTHON3 ?= python3
CARGO ?= cargo
LTO ?= y
FEBUG_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at)
FEBUG_DATE ?= $(shell date $(shell date -d@0 > /dev/null 2>&1 && echo "-d @" || echo "-r ")$(SOURCE_DATE_EPOCH) +"%B %e, %Y")


OUTDIR ?= out/
OBJDIR ?= $(OUTDIR)obj/
BOTHFLAGS := -MD -g -O3 -pipe -Wall -Wextra -Iinclude/
LDFLAGS += -Wl,--as-needed -L$(OUTDIR)
EXAMPLES := $(wildcard examples/*.c examples/*.cpp)
EXAMPLES_RS := $(wildcard examples/*.rs)
MANPAGES := $(wildcard man/*.[0123456789])
FEBUG_VERSION := $(FEBUG_VERSION)
FEBUG_DATE := $(FEBUG_DATE)


SONAME := -soname
SYSTEM := $(shell uname -s)
ifeq "$(SYSTEM)" "NetBSD"
	FUSE_ARGS ?= -lrefuse
else ifeq "$(SYSTEM)" "OpenBSD"
	FUSE_ARGS ?= -lfuse
else ifeq "$(SYSTEM)" "Darwin"
	FUSE_ARGS ?= -lfuse
	LDFLAGS := $(filter-out -Wl,--as-needed,$(LDFLAGS))
	SONAME := -install_name
else
	FUSE_ARGS ?= $(shell $(PKGCONF) --libs --cflags fuse3)
endif


CXXVER := $(shell $(CXX) --version | { read -r l; echo "$$l"; })
ifneq "$(findstring clang,$(CXXVER))" ""
	BOTHFLAGS += -Wpedantic
ifneq "$(findstring Apple,$(CXXVER))" ""
	# CMSG_SPACE() is a macro, and it's decidedly constexpr. i don't care if appleclang can't figure that out
	BOTHFLAGS += -Wno-vla-extension
endif
	ifeq "$(LTO)" "y"
		LDFLAGS += -flto=full  # Clang produces .o files with LLVM bitcode, which cannot be linked to if put in .as
	endif
else
	ifeq "$(LTO)" "y"
		BOTHFLAGS += -flto
	endif
endif

CXXFLAGS += $(BOTHFLAGS) -std=c++20
CFLAGS   += $(BOTHFLAGS) -std=c11


.PHONY : main libfebug++ libfebug libfebug.py examples manpages htmlpages rust-build rust-doc python-build

all : main libfebug++ libfebug libfebug.py examples manpages htmlpages how.png
clean:
	rm -rf $(OUTDIR) $(OBJDIR) how.png

main : $(OUTDIR)febug
libfebug++ : $(OUTDIR)libfebug++.a
libfebug : $(OUTDIR)libfebug.a $(OUTDIR)libfebug.so
libfebug.py : $(OUTDIR)febug.py/febug.py
python-build : $(OUTDIR)febug.py/dist/.built
examples : $(foreach l,$(patsubst %.c,$(OUTDIR)%,$(patsubst %pp,%,$(EXAMPLES))),$(l) $(l)-dont)
manpages : $(patsubst %,$(OUTDIR)%,$(MANPAGES)) $(OBJDIR)man/aliases
htmlpages : $(patsubst %,$(OUTDIR)%.html,$(MANPAGES)) $(OUTDIR)man/style.css
rust-build : $(OUTDIR)febug.rs/target/libfebug.rlib
rust-doc : $(OUTDIR)febug.rs/doc/febug/index.html


$(OUTDIR)febug : main.cpp
	@mkdir -p $(@D)
	$(CXX) $(CPPFLAGS) -DFEBUG_VERSION='$(FEBUG_VERSION)' $(CXXFLAGS) -fno-exceptions -fPIE $< -o$@ $(FUSE_ARGS)


$(OBJDIR)febug++.o : febug.cpp
	@mkdir -p $(@D)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -fPIC -c $< -o$@

$(OUTDIR)libfebug++.a : $(OBJDIR)febug++.o
	@mkdir -p $(@D)
	ar crs $@ $^


$(OBJDIR)febug.o : febug.c
	@mkdir -p $(@D)
	$(CC) $(CPPFLAGS) $(CFLAGS) -fPIC -c $< -o$@

$(OUTDIR)libfebug.a : $(OBJDIR)febug.o
	@mkdir -p $(@D)
	ar crs $@ $^

$(OUTDIR)libfebug.so : $(OBJDIR)febug.o
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -fPIC -Wl,$(SONAME),libfebug.so.0 $< -o$(OUTDIR)libfebug.so.0
	ln -fs libfebug.so.0 $@


$(OUTDIR)febug.py/febug.py : febug.py febug.pyproject README.md
	@mkdir -p $(@D)
	sed -e 's;FEBUG_VERSION;$(FEBUG_VERSION);' -e '/version =/s/-/.dev/' -e '/version =/s/-\(.*\)"/"/' febug.pyproject > $(OUTDIR)febug.py/pyproject.toml
	cp febug.py README.md $(@D)

$(OUTDIR)febug.py/dist/.built : $(OUTDIR)febug.py/febug.py
	cd $(OUTDIR)febug.py && $(PYTHON3) -m build
	@>> $@


$(OUTDIR)examples/% : examples/%.cpp $(OUTDIR)libfebug++.a
	@mkdir -p $(@D)
	$(CXX) $(CPPFLAGS)              $(CXXFLAGS) $(LDFLAGS) -fPIE $< -o$@ -lfebug++

$(OUTDIR)examples/%-dont : examples/%.cpp $(OUTDIR)libfebug++.a
	@mkdir -p $(@D)
	$(CXX) $(CPPFLAGS) -DFEBUG_DONT $(CXXFLAGS) $(LDFLAGS) -fPIE $< -o$@ -lfebug++

$(OUTDIR)examples/% : examples/%.c $(OUTDIR)libfebug.a
	@mkdir -p $(@D)
	$(CC) $(CPPFLAGS)               $(CFLAGS)   $(LDFLAGS) -fPIE $< -o$@ -lfebug

$(OUTDIR)examples/%-dont : examples/%.c $(OUTDIR)libfebug.a
	@mkdir -p $(@D)
	$(CC) $(CPPFLAGS) -DFEBUG_DONT  $(CFLAGS)   $(LDFLAGS) -fPIE $< -o$@ -lfebug


$(OBJDIR)man/aliases : man/aliases
	@mkdir -p $(@D)
	@touch $@
	$(AWK) '!/^$$/ {print "ln -fs " $$1 " $(OUTDIR)man/" $$2}' man/aliases | sh -x

$(OUTDIR)man/% : man/% man/*.h
	@mkdir -p $(@D)
	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<) | \
		$(AWK) '/^$$/ {next}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  \
			$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\e", line); gsub(/\t/, "  ", line); if(line !~ /^##/) print line}; next}  \
			{sub(/^~/, "\\(ti"); gsub(/([^\\])~/, "&_BUT-TI_"); gsub(/~_BUT-TI_/, "\\(ti"); print}') > $@
	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'WARNING: unknown manual section: Dt .* 0$$' -e 'STYLE: operating system explicitly specified: Os febug' -e 'STYLE: input text line longer than 80 bytes' -e 'STYLE: .*OpenBSD' -e 'STYLE: RCS id missing'

$(OUTDIR)man/%.html : $(OUTDIR)man/%
	(cd man/; $(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I",man="%N.%S.html;https://manpages.debian.org/bookworm/%N.%S",style="style.css" ../$^ | \
		sed -Ee 's/ title=".."//g') > $@

$(OUTDIR)man/style.css : man/style.css
	@mkdir -p $(@D)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/README.md : README.md
	@mkdir -p $(@D)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/%.rs : febug.rs/%.rs
	@mkdir -p $(@D)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/examples/%.rs : examples/%.rs
	@mkdir -p $(@D)
	ln -f $^ $@ 2>/dev/null || cp $^ $@

$(OUTDIR)febug.rs/target/libfebug.rlib : $(OUTDIR)febug.rs/Cargo.toml $(OUTDIR)febug.rs/lib.rs $(OUTDIR)febug.rs/build.rs $(OUTDIR)febug.rs/README.md $(patsubst %,$(OUTDIR)febug.rs/%,$(EXAMPLES_RS))
	@mkdir -p $(OUTDIR)examples/
	cd $(dir $<); FEBUG_DONT=1 $(CARGO) build --release --examples
	$(foreach l,$(patsubst %.rs,%,$(EXAMPLES_RS)),mv $(OUTDIR)febug.rs/target/release/$(l) $(OUTDIR)$(l)-dont &&) :
	cd $(dir $<); $(CARGO) build --release --examples
	$(foreach l,$(patsubst %.rs,%,$(EXAMPLES_RS)),mv $(OUTDIR)febug.rs/target/release/$(l) $(OUTDIR)$(l) &&) :

$(OUTDIR)febug.rs/doc/febug/index.html : $(OUTDIR)febug.rs/target/libfebug.rlib
	cd $(dir $<); $(CARGO) doc --release

$(OUTDIR)febug.rs/Cargo.toml : febug.rs/Cargo.toml
	@mkdir -p $(@D)
	sed 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@


how.png : how.dot
	dot -Tpng $^ -o $@


include $(wildcard $(OUTDIR)*.d $(OUTDIR)*/*.d)

=== debian/changelog ===
febug (1.0.0+dfsg-1) unstable; urgency=medium

  * Build-Depends: pkg-config -> pkgconf
  * d/upstream/signing-key.asc, d/watch: pull and verify signature
  * New upstream version 1.0.0+dfsg (+ changelog & NEWS)
  * d/upstream/metadata: add
  * d/copyright & d/rules: update for 1.0.0
  * Add python3-febug package
  * Don't strip libfebug++.a
  * libfebug-dev Depends: libfebug0

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 08 Dec 2023 23:49:55 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Homepage: https://sr.ht/~nabijaczleweli/febug
 Build-Depends: debhelper,
                debhelper-compat (= 13),
-               pkg-config,
+               pkgconf,
                graphviz,
                libfuse3-dev,
 
@@ -47,6 +47,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+         libfebug0
 Tag: implemented-in::c, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C development files
  Applications can register variables to be observable,
@@ -55,7 +56,7 @@
  and format the current state to be displayed
  to the human attempting to debug them.
  .
- This package contains the development files and man-pages for the C library.
+ This package contains the development files and manuals for the C library.
 
 Package: libfebug++-dev
 Recommends: febug
@@ -63,7 +64,7 @@
 Depends: libfebug-dev,
          ${misc:Depends},
          ${shlibs:Depends},
-Tag: implemented-in::c, role::library
+Tag: implemented-in::c++, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files
  Applications can register variables to be observable,
  showing up as files in /var/run/febug/$PID/$VARIABLE,
@@ -71,4 +72,20 @@
  and format the current state to be displayed
  to the human attempting to debug them.
  .
- This package contains the development files and man-pages for the C++ library.
+ This package contains the development files and manuals for the C++ library.
+
+Package: python3-febug
+Recommends: febug
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         python3:any
+Tag: implemented-in::python, role::library
+Description: Cooperative debugging filesystem, inspired by debugfs -- Python 3 library
+ Applications can register variables to be observable,
+ showing up as files in /var/run/febug/$PID/$VARIABLE,
+ and, when opened, (optionally) receive a signal,
+ and format the current state to be displayed
+ to the human attempting to debug them.
+ .
+ This package contains the Python 3 library and manuals therefor.

=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export FEBUG_VERSION := "$(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")"
export TZ := UTC0
export MANDOC := true


override_dh_strip:
	dh_strip -Xlibfebug++.a

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_installsystemduser:
	dh_installsystemduser --no-enable

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs README.md how.png
	cp debian/NEWS.upstream debian/febug/usr/share/doc/febug/NEWS

override_dh_installman:
	dh_installman --language=C

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s/v?(\d\S+)\.tar\.gz/febug-$1\.tar\.gz/,\
dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,\
pgpsigurlmangle=s/$/.asc/" \
  https://git.sr.ht/~nabijaczleweli/febug/refs .*/v?(\d\S+)\.tar\.gz
